﻿/*
 * Calender.c
 *
 * Created: 西暦23年12月23日 22:41:39
 *  Author: Hiroyuki Yamada (Y-Logic)
 */ 

#include "main.h"
#include "Calender.h"

struct sCalender g_calender;


// index 0: 2023/1/1
#include "table.txt"

// year: 00-99
uint16_t GetDayOfYear(uint8_t year)
{
	// leap year: 2004, 2008...
	// not consider 2100 because I am never alive that year
	if((year & 3) == 0) return 366;
	return 365;
}
uint8_t GetDayOfMonth(uint8_t year, uint8_t month)
{
	const uint8_t monthTable[12] = {31,28,31,30, 31,30,31,31, 30,31,30,31};
	
	if(month == 2)
	{
		if((year & 3) == 0) return 29;
	}
	return monthTable[month-1];
}

// month: 1-12, b7 is leap month flag
// day: 1-28
void GetCurMoonCalender(const struct sCalender* pCalender, uint8_t* pYear, uint8_t* pMonth, uint8_t* pDay)
{
	uint8_t i;
	uint16_t idx = 0;
	
	// get index
	for(i=23; i<pCalender->year; i++)
	{
		//idx += GetDayOfYear(i);
	}
	// this year
	for(i=1; i<pCalender->month; i++)
	{
		idx += GetDayOfMonth(pCalender->year, i);
	}
	idx += pCalender->day-1;
	
//	const uint8_t* table = pgm_read_ptr(&g_moonCalenderTable[pCalender->year-23]);
	const uint8_t* table = g_moonCalenderTable[pCalender->year-23];
	*pYear = pgm_read_byte(&table[idx*3 + 0]);
	*pMonth = pgm_read_byte(&table[idx*3 + 1]);
	*pDay = pgm_read_byte(&table[idx*3 + 2]);
	/*
	*pYear = pgm_read_byte(&g_moonCalenderTable[idx*3 + 0]);
	*pMonth = pgm_read_byte(&g_moonCalenderTable[idx*3 + 1]);
	*pDay = pgm_read_byte(&g_moonCalenderTable[idx*3 + 2]);
	*/
}

void UpdateDate()
{
	g_calender.date6 = ((g_calender.mcMonth & 0xF) + g_calender.mcDay) % 6;
	
	// Zeller's congruence
	uint16_t h = g_calender.day;
	if(g_calender.month <= 2)
	{
		h += 26 * (12+g_calender.month + 1) / 10;
		h += (g_calender.year-1);
		h += (g_calender.year-1)/4;
	}
	else
	{
		h += 26 * (g_calender.month + 1) / 10;
		h += g_calender.year;
		h += g_calender.year/4;
	}
	uint8_t c = 20 + (g_calender.year/100); // should be 20 whenever I am alive
	h -= 2*c;
	h += c/4; // should be -35
	g_calender.date7 = (h+6) % 7;
}

static void IncreaseDay()
{
	g_calender.day ++;
	if(g_calender.day > GetDayOfMonth(g_calender.year, g_calender.month))
	{
		g_calender.day = 1;
		g_calender.month += 1;
		if(g_calender.month > 12)
		{
			g_calender.month = 1;
			g_calender.year ++;
		}
	}
	
	GetCurMoonCalender(&g_calender, &g_calender.mcYear, &g_calender.mcMonth, &g_calender.mcDay);
	UpdateDate();
}

// call this per 500ms
void RTC_Tick()
{
	g_calender.subsec ++;
	if((g_calender.subsec & 1) == 0)
	{
		g_calender.sec ++;
		if(g_calender.sec >= 60)
		{
			g_calender.sec = 0;
			g_calender.min ++;
			if(g_calender.min >= 60)
			{
				g_calender.min = 0;
				g_calender.hour ++;
				if(g_calender.hour >= 24)
				{
					g_calender.hour = 0;
					IncreaseDay();
				}
			}
		}
	}
}
