﻿/*
 * Calender.h
 *
 * Created: 西暦23年12月23日 22:41:52
 *  Author: Hiroyuki Yamada (Y-Logic)
 */ 


#ifndef CALENDER_H_
#define CALENDER_H_

struct sCalender
{
	// sun calender
	uint8_t year; // 00 - 99
	uint8_t month; // 1-12
	uint8_t day; // 1-31
	
	uint8_t hour;
	uint8_t min;
	uint8_t sec;
	uint8_t subsec; // 0, 1
	
	uint8_t date7; // 0-6
	uint8_t date6; // 0-5
	
	// moon calender
	uint8_t mcYear;
	uint8_t mcMonth; // b7 is leap flag
	uint8_t mcDay;
};
extern struct sCalender g_calender;


// call this per 500ms
void RTC_Tick();

uint16_t GetDayOfYear(uint8_t year);
uint8_t GetDayOfMonth(uint8_t year, uint8_t month);

// get moon calender ymd
void GetCurMoonCalender(const struct sCalender* pCalender, uint8_t* pYear, uint8_t* pMonth, uint8_t* pDay);

// Update date6, date7 from current day
void UpdateDate();

#endif /* CALENDER_H_ */