/**
 * \file
 *
 * \brief Driver ISR.
 *
 (c) 2020 Microchip Technology Inc. and its subsidiaries.

    Subject to your compliance with these terms,you may use this software and
    any derivatives exclusively with Microchip products.It is your responsibility
    to comply with third party license terms applicable to your use of third party
    software (including open source software) that may accompany Microchip software.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 */

/*
 * Code generated by START.
 *
 * This file will be overwritten when reconfiguring your START project.
 * Please copy examples or other code you want to keep to a separate file
 * to avoid losing it when reconfiguring.
 */

#include <driver_init.h>
#include <compiler.h>
#include "Calender.h"
#include "main.h"

ISR(RTC_CNT_vect)
{

	/* Insert your RTC Overflow interrupt handling code */

	/* Overflow interrupt flag has to be cleared manually */
	RTC.INTFLAGS = RTC_OVF_bm;
	
}

ISR(RTC_PIT_vect)
{
	/* Insert your PIT interrupt handling code here */

	/* The interrupt flag has to be cleared manually */
	RTC.PITINTFLAGS = RTC_PI_bm;
	
	RTC_Tick();
}

void UpdateLEDStatus();
ISR(TCB0_INT_vect)
{

	TCB0.INTFLAGS = TCB_CAPT_bm;
	
	// LED and Switch processing
	UpdateLEDStatus();
}

// 10ms
ISR(TCB1_INT_vect)
{
	static uint8_t cnt;
	if(++cnt >= 50)
	{
		cnt = 0;
		
	}

	TCB1.INTFLAGS = TCB_CAPT_bm;
}

// +5V Power Lost Detected
ISR(PORTD_PORT_vect)
{
	/* Clear interrupt flags */
	VPORTD_INTFLAGS = (1 << 1) | (1 << 2) | (1 << 4) | (1 << 5) | (1 << 6);
	
	/* Insert your PORTD interrupt handling code here */
	if(VSENSE_get_level() == false){
		LowPower_Entry();
	}

	/* Clear interrupt flags */
	VPORTD_INTFLAGS = (1 << 1) | (1 << 2) | (1 << 4) | (1 << 5) | (1 << 6);
}
