from qreki import Kyureki

year_max = 2074

for year in range(2023, year_max):
	print("const uint8_t g_moonCalenderTable_{}[] PROGMEM = ".format(year))
	print("{")
	for month in range(1,13):
		day_table = [31,28,31,30, 31,30,31,31, 30,31,30,31]
		if(year % 4 == 0): day_table[1] = 29
		for day in range(1, day_table[month-1]+1):
			k = Kyureki.from_ymd(year, month, day)
			print( 
				"{:d},{:d},{:d}".format(
				#"0x{}{:02d}{:02d}".format(
				#(k.month + k.day)%6, # 六曜(0-5)
				k.year%100, k.leap_month*0x80 + k.month, k.day), # 旧暦Dex
			 ", // {}/{}/{} = {}".format(year, month,day, k.rokuyou))
	print("};")
	print("")

print("const uint8_t* g_moonCalenderTable[] = {")
for year in range(2023, year_max):
	print("\tg_moonCalenderTable_{}".format(year), ", ")
print("};")
